#include <math.h>
#include <stdio.h>
#include <time.h>
#include <omp.h>
#define N 500
#define am(p,q) (a+p+N*q)
float a[N*N],y[N],x[N],b[N];
int ipvt[N];
main()
{
/*
   Test program for wpp version of sgefa: initial data
   for matrix A and right hand side b are random and
   generated by ggl. Timings for this version are via
   both "clock" from <time.h>, and "walltime" from
   Tonko Racic.
                                 wpp 28/01/2003, ETHZ
*/
   int i,info,j,n,zero;
   static float seed=331.0;
   float ggl(float*);
   double walltime(double*);
   double t0,tw;
   float big,err,errm,bf,fnm1,t1,t2;
   void sgefa(),sgesl();
   n    = N;
   zero = 0;
   for(j=0;j<n;j++){
/*    y[j] = ggl(&seed); */
      y[j] = 1.0;
      b[j] = 0.0;
   }
   fnm1 = 1.0/((float)n);
   for(j=0;j<n;j++){
      for(i=0;i<n;i++){
         if(i<j){
            bf = 0.5*((float)(n-j-1))*fnm1;
         } else {
            bf = 0.5*((float)(n-i-1))*fnm1;
         }
         if(i==j){
             *am(i,i) = 1.0 - 0.1*(0.5-ggl(&seed));
         } else {
             *am(i,j) = bf*(0.5-ggl(&seed));
         }
         b[i] += *am(i,j)*y[j];
      }
   }
/* printf(" Initial A:\n");
   for(i=0;i<n;i++){
      for(j=0;j<n;j++) printf("%e \n ",*am(i,j));
   } */
   t0 = 0.0;
   t1 = ((float)clock())/((float) CLOCKS_PER_SEC);
   tw = walltime(&t0);
   sgefa(a,n,n,ipvt,&info);         /* factor A -> LU */
   t0 = walltime(&tw);
   t2 = ((float)clock())/((float) CLOCKS_PER_SEC);
   t1 = t2 - t1;
   sgesl(a,&n,&n,ipvt,b,&zero);     /* solution step  */
/* printf(" factored A:\n"); 
   for(i=0;i<n;i++){
      for(j=0;j<n;j++) printf("%e \n ",*am(i,j));
   } */

   err  = 0.0;
   errm = 0.0;
   for(j=0;j<n;j++){
       big  = fabsf(b[j]-y[j]);
       errm = (big > errm)?big:errm;
       err  += (b[j]-y[j])*(b[j]-y[j]);
/*     printf("b(%d) = %e, y(%d) = %e\n",j,b[j],j,y[j]); */
   }
/* print errors */
   err = sqrt(err/((float) n));
   printf("\n RMS error in solution for N = %d:",n);
   printf(" err = %e\n",err);
   printf("                          max. abs errm = %e\n",errm);
   printf("               wallclock time for sgefa = %e\n",t0);
   printf("                   clock time for sgefa = %e\n",t1);
}
#include <math.h>
float ggl(float *ds)
{
/* generate u(0,1) distributed random numbers.
   Seed ds must be saved between calls. ggl is
   essentially the same as the IMSL routine RNUM.

   W. Petersen and M. Troyer, 24 Oct. 2002, ETHZ */

   double t,d2=0.2147483647e10;
   t   = (double) *ds;
   t   = fmod(0.16807e5*t,d2);
   *ds = (float) t;
   return((float)((t-1.0e0)/(d2-1.0e0)));
}
# include <sys/time.h>
double walltime(double *t0)
{
   double mic, time;
   double mega=0.000001;
   struct timeval tp;
   struct timezone tzp;
   static long base_sec = 0;
   static long base_usec = 0;

   (void) gettimeofday(&tp, &tzp);
   if (base_sec == 0) {
     base_sec  = tp.tv_sec;
     base_usec = tp.tv_usec;
   }
   time = (double)(tp.tv_sec - base_sec);
   mic = (double)(tp.tv_usec - base_usec);
   time = (time + mic * mega) - *t0;
   return(time);
}
