#define am(p,q) (a+p+q*la)
void sgefa(a,la,n,ip,info)
float *a;
int la,*ip,*info;
{
/* 
   parallel C version of SGEFA wpp 18/4/2000 
*/
   int k,kp1,l,nm1,isamax();
   float t;
   void msaxpy(),sscal(),sswap();

   *info = 0;
   nm1   = n-1;
   for(k=0;k<nm1;k++){
      kp1   = k+1;
      l     = isamax(n-k,am(k,k),1) + k;
      ip[k] = l;
      if((*am(l,k))==0.0){
         *info=k;
         return;
      }
      if(l!=k){
         t        = *am(l,k);
         *am(l,k) = *am(k,k);
         *am(k,k) = t;
      }
      t = -1.0/(*am(k,k)); 
      sscal(n-k-1,t,am(kp1,k),1);
      if(l!=k){
         sswap(n-k-1,am(l,kp1),la,am(k,kp1),la);
      }
      msaxpy(n-k-1,n-k-1,am(k,kp1),n,am(kp1,k),am(kp1,kp1));
   }
}
#undef am
#define ym(p,q) (y+p+q*n)
void msaxpy(nr,nc,a,n,x,y)
int nr,nc,n;
float *a,*x,*y;
{
/* 
   multiple SAXY operation: y(*,j) <- a(j)*x[*] + y(*,j) 
   for parallel version of sgefa. Here is the layout:

              a[0],     a[1],     a[2],     ..., a[n-1]
       x[0]   y(0,0),   y(0,1),   y(0,2),   ..., y(0,n-1) 
       x[1]   y(1,0),   y(1,1),   y(1,2),   ..., y(1,n-1) 
       x[2]   y(2,0),   y(2,1),   y(2,2),   ..., y(2,n-1)
                 .... 
       x[n-1] y(n-1,0), y(n-1,1), y(n-1,2), ..., y(n-1,n-1)

   This multiple SAXPY routine does the same calculation
   as the Level 2 BLAS routine SGER() - a rank 1 unpdate. 
                                           wpp 29/01/2003 
*/
   int i,j;
#pragma omp parallel shared(nr,nc,a,x,y) private(i,j) 
/* #pragma omp for schedule(dynamic,1) nowait */
#pragma omp for 
   for(j=0;j<nc;j++){
      for(i=0;i<nr;i++){
         *ym(i,j) += a[j*n]*x[i];
      }
   }

}
